/* Generated by wayland-scanner 1.23.1 */

#ifndef GAMING_INPUT_UNSTABLE_V2_CLIENT_PROTOCOL_H
#define GAMING_INPUT_UNSTABLE_V2_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_gaming_input_unstable_v2 The gaming_input_unstable_v2 protocol
 * @section page_ifaces_gaming_input_unstable_v2 Interfaces
 * - @subpage page_iface_zcr_gaming_input_v2 - extends wl_seat with gaming input devices
 * - @subpage page_iface_zcr_gaming_seat_v2 - controller object for all gaming devices of a seat
 * - @subpage page_iface_zcr_gamepad_v2 - gamepad input device
 * - @subpage page_iface_zcr_gamepad_vibrator_v2 - vibrator interface for a gamepad
 * @section page_copyright_gaming_input_unstable_v2 Copyright
 * <pre>
 *
 * Copyright 2016 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct wl_seat;
struct zcr_gamepad_v2;
struct zcr_gamepad_vibrator_v2;
struct zcr_gaming_input_v2;
struct zcr_gaming_seat_v2;

#ifndef ZCR_GAMING_INPUT_V2_INTERFACE
#define ZCR_GAMING_INPUT_V2_INTERFACE
/**
 * @page page_iface_zcr_gaming_input_v2 zcr_gaming_input_v2
 * @section page_iface_zcr_gaming_input_v2_desc Description
 *
 * A global interface to provide gaming input devices for a given seat.
 *
 * Currently only gamepad devices are supported.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and uinterface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 * @section page_iface_zcr_gaming_input_v2_api API
 * See @ref iface_zcr_gaming_input_v2.
 */
/**
 * @defgroup iface_zcr_gaming_input_v2 The zcr_gaming_input_v2 interface
 *
 * A global interface to provide gaming input devices for a given seat.
 *
 * Currently only gamepad devices are supported.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and uinterface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 */
extern const struct wl_interface zcr_gaming_input_v2_interface;
#endif
#ifndef ZCR_GAMING_SEAT_V2_INTERFACE
#define ZCR_GAMING_SEAT_V2_INTERFACE
/**
 * @page page_iface_zcr_gaming_seat_v2 zcr_gaming_seat_v2
 * @section page_iface_zcr_gaming_seat_v2_desc Description
 *
 * An object that provides access to all the gaming devices of a seat.
 * When a gamepad is connected, the compositor will send gamepad_added event.
 * @section page_iface_zcr_gaming_seat_v2_api API
 * See @ref iface_zcr_gaming_seat_v2.
 */
/**
 * @defgroup iface_zcr_gaming_seat_v2 The zcr_gaming_seat_v2 interface
 *
 * An object that provides access to all the gaming devices of a seat.
 * When a gamepad is connected, the compositor will send gamepad_added event.
 */
extern const struct wl_interface zcr_gaming_seat_v2_interface;
#endif
#ifndef ZCR_GAMEPAD_V2_INTERFACE
#define ZCR_GAMEPAD_V2_INTERFACE
/**
 * @page page_iface_zcr_gamepad_v2 zcr_gamepad_v2
 * @section page_iface_zcr_gamepad_v2_desc Description
 *
 * The zcr_gamepad_v2 interface represents one or more gamepad input devices,
 * which are reported as a normalized 'Standard Gamepad' as it is specified
 * by the W3C Gamepad API at: https://w3c.github.io/gamepad/#remapping
 * @section page_iface_zcr_gamepad_v2_api API
 * See @ref iface_zcr_gamepad_v2.
 */
/**
 * @defgroup iface_zcr_gamepad_v2 The zcr_gamepad_v2 interface
 *
 * The zcr_gamepad_v2 interface represents one or more gamepad input devices,
 * which are reported as a normalized 'Standard Gamepad' as it is specified
 * by the W3C Gamepad API at: https://w3c.github.io/gamepad/#remapping
 */
extern const struct wl_interface zcr_gamepad_v2_interface;
#endif
#ifndef ZCR_GAMEPAD_VIBRATOR_V2_INTERFACE
#define ZCR_GAMEPAD_VIBRATOR_V2_INTERFACE
/**
 * @page page_iface_zcr_gamepad_vibrator_v2 zcr_gamepad_vibrator_v2
 * @section page_iface_zcr_gamepad_vibrator_v2_desc Description
 *
 * An interface that provides access to the vibrator of a gamepad. Requests can be
 * sent to make the gamepad vibrate and to stop an ongoing vibration.
 * @section page_iface_zcr_gamepad_vibrator_v2_api API
 * See @ref iface_zcr_gamepad_vibrator_v2.
 */
/**
 * @defgroup iface_zcr_gamepad_vibrator_v2 The zcr_gamepad_vibrator_v2 interface
 *
 * An interface that provides access to the vibrator of a gamepad. Requests can be
 * sent to make the gamepad vibrate and to stop an ongoing vibration.
 */
extern const struct wl_interface zcr_gamepad_vibrator_v2_interface;
#endif

#define ZCR_GAMING_INPUT_V2_GET_GAMING_SEAT 0
#define ZCR_GAMING_INPUT_V2_DESTROY 1


/**
 * @ingroup iface_zcr_gaming_input_v2
 */
#define ZCR_GAMING_INPUT_V2_GET_GAMING_SEAT_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gaming_input_v2
 */
#define ZCR_GAMING_INPUT_V2_DESTROY_SINCE_VERSION 1

/** @ingroup iface_zcr_gaming_input_v2 */
static inline void
zcr_gaming_input_v2_set_user_data(struct zcr_gaming_input_v2 *zcr_gaming_input_v2, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_gaming_input_v2, user_data);
}

/** @ingroup iface_zcr_gaming_input_v2 */
static inline void *
zcr_gaming_input_v2_get_user_data(struct zcr_gaming_input_v2 *zcr_gaming_input_v2)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_gaming_input_v2);
}

static inline uint32_t
zcr_gaming_input_v2_get_version(struct zcr_gaming_input_v2 *zcr_gaming_input_v2)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_gaming_input_v2);
}

/**
 * @ingroup iface_zcr_gaming_input_v2
 *
 * Get a gaming seat object for a given seat. Gaming seat provides access
 * to gaming devices
 */
static inline struct zcr_gaming_seat_v2 *
zcr_gaming_input_v2_get_gaming_seat(struct zcr_gaming_input_v2 *zcr_gaming_input_v2, struct wl_seat *seat)
{
	struct wl_proxy *gaming_seat;

	gaming_seat = wl_proxy_marshal_flags((struct wl_proxy *) zcr_gaming_input_v2,
			 ZCR_GAMING_INPUT_V2_GET_GAMING_SEAT, &zcr_gaming_seat_v2_interface, wl_proxy_get_version((struct wl_proxy *) zcr_gaming_input_v2), 0, NULL, seat);

	return (struct zcr_gaming_seat_v2 *) gaming_seat;
}

/**
 * @ingroup iface_zcr_gaming_input_v2
 *
 * Destroy gaming_input object. Objects created from this object are
 * unaffected and should be destroyed separately.
 */
static inline void
zcr_gaming_input_v2_destroy(struct zcr_gaming_input_v2 *zcr_gaming_input_v2)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_gaming_input_v2,
			 ZCR_GAMING_INPUT_V2_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_gaming_input_v2), WL_MARSHAL_FLAG_DESTROY);
}

#ifndef ZCR_GAMING_SEAT_V2_BUS_TYPE_ENUM
#define ZCR_GAMING_SEAT_V2_BUS_TYPE_ENUM
/**
 * @ingroup iface_zcr_gaming_seat_v2
 * gamepad device bus type
 *
 * Device connection type e.g. Bluetooth
 */
enum zcr_gaming_seat_v2_bus_type {
	/**
	 * Universal Serial Bus
	 */
	ZCR_GAMING_SEAT_V2_BUS_TYPE_USB = 0,
	/**
	 * Bluetooth
	 */
	ZCR_GAMING_SEAT_V2_BUS_TYPE_BLUETOOTH = 1,
};
#endif /* ZCR_GAMING_SEAT_V2_BUS_TYPE_ENUM */

/**
 * @ingroup iface_zcr_gaming_seat_v2
 * @struct zcr_gaming_seat_v2_listener
 */
struct zcr_gaming_seat_v2_listener {
	/**
	 * gamepad added event
	 *
	 * Notification that there is gamepad connected at this seat.
	 * @param gamepad new connected gamepad
	 */
	void (*gamepad_added)(void *data,
			      struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2,
			      struct zcr_gamepad_v2 *gamepad);
	/**
	 * gamepad added event
	 *
	 * Notification that there is gamepad connected at this seat.
	 * @param gamepad new connected gamepad
	 * @param name name of the gamepad device
	 * @param bus type of the device connection e.g. Bluetooth
	 * @param vendor_id vendor ID of the gamepad device
	 * @param product_id product ID of the gamepad device
	 * @param version product version of the gamepad device
	 */
	void (*gamepad_added_with_device_info)(void *data,
					       struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2,
					       struct zcr_gamepad_v2 *gamepad,
					       const char *name,
					       uint32_t bus,
					       uint32_t vendor_id,
					       uint32_t product_id,
					       uint32_t version);
};

/**
 * @ingroup iface_zcr_gaming_seat_v2
 */
static inline int
zcr_gaming_seat_v2_add_listener(struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2,
				const struct zcr_gaming_seat_v2_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zcr_gaming_seat_v2,
				     (void (**)(void)) listener, data);
}

#define ZCR_GAMING_SEAT_V2_DESTROY 0

/**
 * @ingroup iface_zcr_gaming_seat_v2
 */
#define ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gaming_seat_v2
 */
#define ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED_WITH_DEVICE_INFO_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_gaming_seat_v2
 */
#define ZCR_GAMING_SEAT_V2_DESTROY_SINCE_VERSION 1

/** @ingroup iface_zcr_gaming_seat_v2 */
static inline void
zcr_gaming_seat_v2_set_user_data(struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_gaming_seat_v2, user_data);
}

/** @ingroup iface_zcr_gaming_seat_v2 */
static inline void *
zcr_gaming_seat_v2_get_user_data(struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_gaming_seat_v2);
}

static inline uint32_t
zcr_gaming_seat_v2_get_version(struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_gaming_seat_v2);
}

/**
 * @ingroup iface_zcr_gaming_seat_v2
 *
 * Destroy gaming_seat object. Objects created from this object are
 * unaffected and should be destroyed separately.
 */
static inline void
zcr_gaming_seat_v2_destroy(struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_gaming_seat_v2,
			 ZCR_GAMING_SEAT_V2_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_gaming_seat_v2), WL_MARSHAL_FLAG_DESTROY);
}

#ifndef ZCR_GAMEPAD_V2_BUTTON_STATE_ENUM
#define ZCR_GAMEPAD_V2_BUTTON_STATE_ENUM
/**
 * @ingroup iface_zcr_gamepad_v2
 * physical button state
 *
 * Describes the physical state of a button that produced the button
 * event.
 */
enum zcr_gamepad_v2_button_state {
	/**
	 * the button is not pressed
	 */
	ZCR_GAMEPAD_V2_BUTTON_STATE_RELEASED = 0,
	/**
	 * the button is pressed
	 */
	ZCR_GAMEPAD_V2_BUTTON_STATE_PRESSED = 1,
};
#endif /* ZCR_GAMEPAD_V2_BUTTON_STATE_ENUM */

/**
 * @ingroup iface_zcr_gamepad_v2
 * @struct zcr_gamepad_v2_listener
 */
struct zcr_gamepad_v2_listener {
	/**
	 * gamepad removed
	 *
	 * Removed event is send when the gamepad is disconnected. The
	 * client should expect no more event and call destroy.
	 *
	 * This event cannot be used as destructor as requests (e.g.
	 * vibration) might be added to this interface.
	 */
	void (*removed)(void *data,
			struct zcr_gamepad_v2 *zcr_gamepad_v2);
	/**
	 * axis change event
	 *
	 * Notification of axis change.
	 *
	 * The axis id specifies which axis has changed as defined by the
	 * W3C 'Standard Gamepad'.
	 *
	 * The value is calibrated and normalized to the -1 to 1 range.
	 * @param time timestamp with millisecond granularity
	 * @param axis axis that produced this event
	 * @param value new value of axis
	 */
	void (*axis)(void *data,
		     struct zcr_gamepad_v2 *zcr_gamepad_v2,
		     uint32_t time,
		     uint32_t axis,
		     wl_fixed_t value);
	/**
	 * Gamepad button changed
	 *
	 * Notification of button change.
	 *
	 * The button id specifies which button has changed as defined by
	 * the W3C 'Standard Gamepad'.
	 *
	 * A button can have a digital and an analog value. The analog
	 * value is normalized to a 0 to 1 range. If a button does not
	 * provide an analog value, it will be derived from the digital
	 * state.
	 * @param time timestamp with millisecond granularity
	 * @param button id of button
	 * @param state digital state of the button
	 * @param analog analog value of the button
	 */
	void (*button)(void *data,
		       struct zcr_gamepad_v2 *zcr_gamepad_v2,
		       uint32_t time,
		       uint32_t button,
		       uint32_t state,
		       wl_fixed_t analog);
	/**
	 * Notifies end of a series of gamepad changes.
	 *
	 * Indicates the end of a set of events that logically belong
	 * together. A client is expected to accumulate the data in all
	 * events within the frame before proceeding.
	 * @param time timestamp with millisecond granularity
	 */
	void (*frame)(void *data,
		      struct zcr_gamepad_v2 *zcr_gamepad_v2,
		      uint32_t time);
	/**
	 * an axis is added
	 *
	 * Adds an axis to the gamepad. Only called when the gamepad was
	 * created by gamepad_added_with_device_info. The values are
	 * compatible with input_absinfo.
	 * @param index An index of the axis
	 * @param min_value minimum value of the axis
	 * @param max_value maximum value of the axis
	 * @param flat input within this value are ignored
	 * @param fuzz used to filter noise
	 * @param resolution resolution of input in units per millimeter, or units per radian for rotational axes.
	 */
	void (*axis_added)(void *data,
			   struct zcr_gamepad_v2 *zcr_gamepad_v2,
			   uint32_t index,
			   int32_t min_value,
			   int32_t max_value,
			   int32_t flat,
			   int32_t fuzz,
			   int32_t resolution);
	/**
	 * Gamepad activated
	 *
	 * Activates the gamepad i.e. the gamepad will be visible to
	 * applications after this event is fired. All axis_added events
	 * should be sent before this event. Only called when the gamepad
	 * was created by gamepad_added_with_device_info.
	 */
	void (*activated)(void *data,
			  struct zcr_gamepad_v2 *zcr_gamepad_v2);
	/**
	 * a vibrator is added
	 *
	 * Adds a vibrator to the gamepad. Only called if server has
	 * verified that gamepad has a vibrator. The vibrator(s) for a
	 * gamepad are expected to be added before the "activated" event is
	 * called.
	 * @param vibrator the gamepad vibrator
	 * @since 2
	 */
	void (*vibrator_added)(void *data,
			       struct zcr_gamepad_v2 *zcr_gamepad_v2,
			       struct zcr_gamepad_vibrator_v2 *vibrator);
};

/**
 * @ingroup iface_zcr_gamepad_v2
 */
static inline int
zcr_gamepad_v2_add_listener(struct zcr_gamepad_v2 *zcr_gamepad_v2,
			    const struct zcr_gamepad_v2_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zcr_gamepad_v2,
				     (void (**)(void)) listener, data);
}

#define ZCR_GAMEPAD_V2_DESTROY 0

/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_REMOVED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_AXIS_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_BUTTON_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_FRAME_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_AXIS_ADDED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_ACTIVATED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_VIBRATOR_ADDED_SINCE_VERSION 2

/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_DESTROY_SINCE_VERSION 1

/** @ingroup iface_zcr_gamepad_v2 */
static inline void
zcr_gamepad_v2_set_user_data(struct zcr_gamepad_v2 *zcr_gamepad_v2, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_gamepad_v2, user_data);
}

/** @ingroup iface_zcr_gamepad_v2 */
static inline void *
zcr_gamepad_v2_get_user_data(struct zcr_gamepad_v2 *zcr_gamepad_v2)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_gamepad_v2);
}

static inline uint32_t
zcr_gamepad_v2_get_version(struct zcr_gamepad_v2 *zcr_gamepad_v2)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_gamepad_v2);
}

/**
 * @ingroup iface_zcr_gamepad_v2
 *
 * Destroy gamepad. Instances created from this gamepad are unaffected
 * and should be destroyed separately.
 */
static inline void
zcr_gamepad_v2_destroy(struct zcr_gamepad_v2 *zcr_gamepad_v2)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_gamepad_v2,
			 ZCR_GAMEPAD_V2_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_gamepad_v2), WL_MARSHAL_FLAG_DESTROY);
}

#define ZCR_GAMEPAD_VIBRATOR_V2_VIBRATE 0
#define ZCR_GAMEPAD_VIBRATOR_V2_CANCEL_VIBRATION 1
#define ZCR_GAMEPAD_VIBRATOR_V2_DESTROY 2


/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 */
#define ZCR_GAMEPAD_VIBRATOR_V2_VIBRATE_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 */
#define ZCR_GAMEPAD_VIBRATOR_V2_CANCEL_VIBRATION_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 */
#define ZCR_GAMEPAD_VIBRATOR_V2_DESTROY_SINCE_VERSION 2

/** @ingroup iface_zcr_gamepad_vibrator_v2 */
static inline void
zcr_gamepad_vibrator_v2_set_user_data(struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_gamepad_vibrator_v2, user_data);
}

/** @ingroup iface_zcr_gamepad_vibrator_v2 */
static inline void *
zcr_gamepad_vibrator_v2_get_user_data(struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_gamepad_vibrator_v2);
}

static inline uint32_t
zcr_gamepad_vibrator_v2_get_version(struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_gamepad_vibrator_v2);
}

/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 *
 * Triggers the vibration event on the gamepad vibrator. The gamepad is only allowed to
 * vibrate while the window is in focus. The values in the timings array are 64-bit integers
 * and the values in the amplitudes array are unsigned 8-bit integers.
 * The timings array and the amplitudes array are of the same length.
 * For each timing/amplitude pair, the amplitude determines the strength of
 * the vibration and the timing determines the length of the vibration in milliseconds.
 * Amplitude values must be between 0 and 255. An amplitude of 0 implies no vibration
 * and any timing/amplitude pair with a timing value of 0 is ignored.
 * The repeat argument determines the index at which the vibration pattern to repeat begins.
 * A repeat value of -1 disables repetition. If repetition is enabled, the vibration
 * pattern will repeat indefinitely until stopped, or when focus is lost.
 */
static inline void
zcr_gamepad_vibrator_v2_vibrate(struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2, struct wl_array *timings, struct wl_array *amplitudes, int32_t repeat)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_gamepad_vibrator_v2,
			 ZCR_GAMEPAD_VIBRATOR_V2_VIBRATE, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_gamepad_vibrator_v2), 0, timings, amplitudes, repeat);
}

/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 *
 * Cancels the currently ongoing vibration event on the gamepad vibrator.
 */
static inline void
zcr_gamepad_vibrator_v2_cancel_vibration(struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_gamepad_vibrator_v2,
			 ZCR_GAMEPAD_VIBRATOR_V2_CANCEL_VIBRATION, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_gamepad_vibrator_v2), 0);
}

/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 */
static inline void
zcr_gamepad_vibrator_v2_destroy(struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_gamepad_vibrator_v2,
			 ZCR_GAMEPAD_VIBRATOR_V2_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_gamepad_vibrator_v2), WL_MARSHAL_FLAG_DESTROY);
}

#ifdef  __cplusplus
}
#endif

#endif
