// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_VIEWPORTER_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_VIEWPORTER_SHIM_H_

#include "viewporter-client-protocol.h"  // NOLINT(build/include_directory)
#include "viewporter-server-protocol.h"  // NOLINT(build/include_directory)


class WpViewporterShim {
  public:
    WpViewporterShim() = default;
    WpViewporterShim(WpViewporterShim&&) = delete;
    WpViewporterShim& operator=(WpViewporterShim&&) = delete;
    virtual ~WpViewporterShim() = default;

    virtual void set_user_data(struct wp_viewporter* wp_viewporter, void* user_data);

    virtual void* get_user_data(struct wp_viewporter* wp_viewporter);
    virtual void destroy(
        struct wp_viewporter *wp_viewporter);
    
    virtual struct wp_viewport* get_viewport(
        struct wp_viewporter *wp_viewporter,
        struct wl_surface* surface);
    };

WpViewporterShim* wp_viewporter_shim();
void set_wp_viewporter_shim (WpViewporterShim* shim);

class WpViewportShim {
  public:
    WpViewportShim() = default;
    WpViewportShim(WpViewportShim&&) = delete;
    WpViewportShim& operator=(WpViewportShim&&) = delete;
    virtual ~WpViewportShim() = default;

    virtual void set_user_data(struct wp_viewport* wp_viewport, void* user_data);

    virtual void* get_user_data(struct wp_viewport* wp_viewport);
    virtual void destroy(
        struct wp_viewport *wp_viewport);
    
    virtual void set_source(
        struct wp_viewport *wp_viewport,
        wl_fixed_t x,
        wl_fixed_t y,
        wl_fixed_t width,
        wl_fixed_t height);
    
    virtual void set_destination(
        struct wp_viewport *wp_viewport,
        int32_t width,
        int32_t height);
    };

WpViewportShim* wp_viewport_shim();
void set_wp_viewport_shim (WpViewportShim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_VIEWPORTER_SHIM_H_