/* Generated by wayland-scanner 1.23.1 */

/*
 * Copyright 2017 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

#ifndef __has_attribute
# define __has_attribute(x) 0  /* Compatibility with non-clang compilers. */
#endif

#if (__has_attribute(visibility) || defined(__GNUC__) && __GNUC__ >= 4)
#define WL_PRIVATE __attribute__ ((visibility("hidden")))
#else
#define WL_PRIVATE
#endif

extern const struct wl_interface wl_output_interface;
extern const struct wl_interface wl_surface_interface;
extern const struct wl_interface xdg_popup_interface;
extern const struct wl_interface xdg_toplevel_interface;
extern const struct wl_interface zaura_output_interface;
extern const struct wl_interface zaura_popup_interface;
extern const struct wl_interface zaura_surface_interface;
extern const struct wl_interface zaura_toplevel_interface;

static const struct wl_interface *aura_shell_types[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&zaura_surface_interface,
	&wl_surface_interface,
	&zaura_output_interface,
	&wl_output_interface,
	&zaura_toplevel_interface,
	&xdg_toplevel_interface,
	&zaura_popup_interface,
	&xdg_popup_interface,
	&wl_surface_interface,
	&wl_surface_interface,
	&zaura_surface_interface,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&wl_output_interface,
};

static const struct wl_message zaura_shell_requests[] = {
	{ "get_aura_surface", "no", aura_shell_types + 5 },
	{ "get_aura_output", "2no", aura_shell_types + 7 },
	{ "surface_submission_in_pixel_coordinates", "26", aura_shell_types + 0 },
	{ "get_aura_toplevel_for_xdg_toplevel", "27no", aura_shell_types + 9 },
	{ "get_aura_popup_for_xdg_popup", "28no", aura_shell_types + 11 },
	{ "release", "38", aura_shell_types + 0 },
};

static const struct wl_message zaura_shell_events[] = {
	{ "layout_mode", "11u", aura_shell_types + 0 },
	{ "bug_fix", "14u", aura_shell_types + 0 },
	{ "desks_changed", "22a", aura_shell_types + 0 },
	{ "desk_activation_changed", "22i", aura_shell_types + 0 },
	{ "activated", "24?o?o", aura_shell_types + 13 },
};

WL_PRIVATE const struct wl_interface zaura_shell_interface = {
	"zaura_shell", 38,
	6, zaura_shell_requests,
	5, zaura_shell_events,
};

static const struct wl_message zaura_surface_requests[] = {
	{ "set_frame", "u", aura_shell_types + 0 },
	{ "set_parent", "2?oii", aura_shell_types + 15 },
	{ "set_frame_colors", "3uu", aura_shell_types + 0 },
	{ "set_startup_id", "4?s", aura_shell_types + 0 },
	{ "set_application_id", "5?s", aura_shell_types + 0 },
	{ "set_client_surface_id", "7i", aura_shell_types + 0 },
	{ "set_occlusion_tracking", "8", aura_shell_types + 0 },
	{ "unset_occlusion_tracking", "8", aura_shell_types + 0 },
	{ "activate", "9", aura_shell_types + 0 },
	{ "draw_attention", "9", aura_shell_types + 0 },
	{ "set_fullscreen_mode", "10u", aura_shell_types + 0 },
	{ "set_client_surface_str_id", "12s", aura_shell_types + 0 },
	{ "set_server_start_resize", "15", aura_shell_types + 0 },
	{ "intent_to_snap", "16u", aura_shell_types + 0 },
	{ "set_snap_left", "16", aura_shell_types + 0 },
	{ "set_snap_right", "16", aura_shell_types + 0 },
	{ "unset_snap", "16", aura_shell_types + 0 },
	{ "set_window_session_id", "18i", aura_shell_types + 0 },
	{ "set_can_go_back", "19", aura_shell_types + 0 },
	{ "unset_can_go_back", "19", aura_shell_types + 0 },
	{ "set_pip", "20", aura_shell_types + 0 },
	{ "unset_pip", "20", aura_shell_types + 0 },
	{ "set_aspect_ratio", "20ii", aura_shell_types + 0 },
	{ "move_to_desk", "22i", aura_shell_types + 0 },
	{ "set_initial_workspace", "23s", aura_shell_types + 0 },
	{ "set_pin", "25i", aura_shell_types + 0 },
	{ "unset_pin", "25", aura_shell_types + 0 },
	{ "release", "38", aura_shell_types + 0 },
};

static const struct wl_message zaura_surface_events[] = {
	{ "occlusion_changed", "8fu", aura_shell_types + 0 },
	{ "lock_frame_normal", "17", aura_shell_types + 0 },
	{ "unlock_frame_normal", "17", aura_shell_types + 0 },
	{ "occlusion_state_changed", "21u", aura_shell_types + 0 },
	{ "desk_changed", "22i", aura_shell_types + 0 },
	{ "start_throttle", "29", aura_shell_types + 0 },
	{ "end_throttle", "29", aura_shell_types + 0 },
};

WL_PRIVATE const struct wl_interface zaura_surface_interface = {
	"zaura_surface", 38,
	28, zaura_surface_requests,
	7, zaura_surface_events,
};

static const struct wl_message zaura_output_requests[] = {
	{ "release", "38", aura_shell_types + 0 },
};

static const struct wl_message zaura_output_events[] = {
	{ "scale", "2uu", aura_shell_types + 0 },
	{ "connection", "5u", aura_shell_types + 0 },
	{ "device_scale_factor", "5u", aura_shell_types + 0 },
	{ "insets", "33iiii", aura_shell_types + 0 },
	{ "logical_transform", "34i", aura_shell_types + 0 },
};

WL_PRIVATE const struct wl_interface zaura_output_interface = {
	"zaura_output", 38,
	1, zaura_output_requests,
	5, zaura_output_events,
};

static const struct wl_message zaura_toplevel_requests[] = {
	{ "set_orientation_lock", "26u", aura_shell_types + 0 },
	{ "surface_submission_in_pixel_coordinates", "28", aura_shell_types + 0 },
	{ "set_supports_screen_coordinates", "29", aura_shell_types + 0 },
	{ "set_window_bounds", "29iiiio", aura_shell_types + 18 },
	{ "set_restore_info", "30ii", aura_shell_types + 0 },
	{ "set_system_modal", "31", aura_shell_types + 0 },
	{ "unset_system_modal", "31", aura_shell_types + 0 },
	{ "set_restore_info_with_window_id_source", "32is", aura_shell_types + 0 },
	{ "set_decoration", "35u", aura_shell_types + 0 },
	{ "release", "38", aura_shell_types + 0 },
};

static const struct wl_message zaura_toplevel_events[] = {
	{ "configure", "29iiiia", aura_shell_types + 0 },
	{ "origin_change", "29ii", aura_shell_types + 0 },
};

WL_PRIVATE const struct wl_interface zaura_toplevel_interface = {
	"zaura_toplevel", 38,
	10, zaura_toplevel_requests,
	2, zaura_toplevel_events,
};

static const struct wl_message zaura_popup_requests[] = {
	{ "surface_submission_in_pixel_coordinates", "28", aura_shell_types + 0 },
	{ "set_decoration", "35u", aura_shell_types + 0 },
	{ "set_menu", "37", aura_shell_types + 0 },
	{ "release", "38", aura_shell_types + 0 },
};

WL_PRIVATE const struct wl_interface zaura_popup_interface = {
	"zaura_popup", 38,
	4, zaura_popup_requests,
	0, NULL,
};

